" Language:    Nomsu
" Maintainer:  Bruce Hill <bruce@bruce-hill.com>
" License:     WTFPL

" Bail if our syntax is already loaded.
if exists('b:current_syntax') && b:current_syntax == 'nomsu'
  finish
endif

" Highlight long strings.
syn sync minlines=100

" Regular strings

syn region nomsuString1 start=/"/ skip=/\\\\\|\\"/ end=/"/
hi def link nomsuString1 String
syn region nomsuString2 start=/"\.\."/ end=/\(\n[ \t]*[^ \t|]\)\@=/
hi def link nomsuString2 String
syn region nomsuComment start=/(#/ end=/#)/ contains=nomsuComment
hi def link nomsuComment Comment

syn match nomsuVar /\v\%[a-zA-Z0-9_'+*/^&$@#-]*/
hi def link nomsuVar Identifier

syn match nomsuNumber /\v([a-zA-Z])@<!\d+\.\d+/
syn match nomsuNumber /\v([a-zA-Z])@<!\d+/
hi def link nomsuNumber Number

syn match nomsuIndentor /\[\.\.\]/
syn match nomsuIndentor /(\.\.)/
syn match nomsuIndentor /\.\.\s*$/
syn match nomsuIndentor /^\s*\.\./
hi def link nomsuIndentor Special

syn match nomsuIndentor /\.\./
hi def link nomsuIndentor Delimiter

syn match nomsuComma /,/
hi def link nomsuComma Delimiter

syn match nomsuThunk /:/
hi def link nomsuThunk Structure

syn match nomsuToken /\v(\%)@<!\%[a-zA-Z_'+*/^&$@#-][a-zA-Z0-9_'+*/^&$@#-]*/
hi def link nomsuToken Function

if !exists('b:current_syntax')
  let b:current_syntax = 'nomsu'
endif
